基于OSGi的Virgo环境搭建(一)——环境篇

 由  rocky.wang 发布

1.背景

最近要将web项目模块化以支持热插拔、动态扩展等功能,因此我们开始研究如何将OSGi引入web项目。关于OSGi,大家可以参考OSGi研究与总结。现在主流的j2EE框架都离不开Spring,因此,将OSGi与Spring进行无缝整合就成为了引入OSGi的关键。值得庆幸的是,Spring早在08年就已对OSGi进行大力支持,并开发了子项目SpringDM与OSGi进行完美融合。但是,自从3.2版本之后,为了Gradle,Spring摒弃OSGi(关于为什么摒弃OSGi,大家可以参考http://www.infoq.com/news/2012/10/spring-osgi-gradle),关于OSGi在J2EE中的应用,大家也有些争论,可谓是仁者见仁智者见智,说到底,还是对OSGi研究的不够深入,导致OSGi在项目中发挥不出关键作用以致成为累赘。

总之,没尝试过OSGi的人是没有发言权的,基于这样的背景,下面我们就来构建Spring Tools Suite(STS)+ Virgo 的开发环境,为我们接下来深入研究OSGi在Web项目中的应用打下坚实基础。

2.预备知识

在开始之前,先简单介绍一下涉及到的名词概念,了解OSGi以及Virgo的同学可以直接无视。

什么是OSGi?

简单的说,它是一套规范及标准,支持java语言模块化的系统。我们常用的Eclipse就是基于OSGi标准开发的。详情介绍http://developer.51cto.com/art/200909/152190.htm)

什么是STS?

基于Eclipse的一套IDE开发工具,简单说,就是Eclipse + STS插件。

什么是Virgo Tomcat Server?

就是将Tomcat进行包装,集成了OSGi环境的Server。详细介绍 http://www.ha97.com/5152.html

什么是Maven?

这个就不多说了,google一下就清楚了。

3.环境搭建

好,我们正式开始搭建过程。

3.1步骤一:

下载STS开发环境,地址http://spring.io/tools/sts/all,只能下载最新版本,分为绿色解压版及安装版,下载解压版即可。当然,如果你也可以下载Spring Tool Suite的插件直接安装到你的Eclipse环境中,该插件大概有130M左右。

3.2步骤二:

下载Virgo Server,地址http://www.eclipse.org/virgo/download/,我们采用的是基于tomcat的。

3.3步骤三:

配置Virgo Server。

我们需要将下载的Virgo Server集成到STS环境中,首先,在STS IDE中安装virgo tools插件,通过Help->Install New Software,弹出如下界面。

在STS IDE中安装virgo tools,通过Help->Install New Software,弹出如下界面。

点击Add,输入

Name:virgo

Location:http://download.eclipse.org/virgo/milestone/tooling

勾选Eclipse Virgo Tools插件,然后Next进行下载及安装。

安装完成后重启STS。

然后,配置Server,也就是我们使用的virgo应用服务器。

点击Add,在弹出的配置界面中选择EclipseRT下面的Virgo Runtime。

选择EclipseRT下面的Virgo Runtime并勾选create a new local server。

填写Virgo Server的Name,点击Browser选择下载的Virgo Server的路径。

完成后,在Server视图中可以看到我们创建的VirgoServer,下面的VmwarevFabric tc Server是这个版本的STS环境自带的,不用管。

3.4步骤四:

配置Maven。(如果不清楚Maven是什么的同学可以去Google一下,此处是Maven下载的地址http://maven.apache.org/download.cgi

重启之后选择windows->preferences->Maven对maven进行配置。

建议不要使用Embedded内嵌的Maven,《Maven实战》上说不太稳定,详见《Maven实战》第47页2.7.3。

最后,让我们测试一下搭建的环境,在STS中启动Virgo Server。

可以看到virgo

启动后就是加载各个osgi的插件

打开浏览器,输入http://localhost:8080/

得到默认的启动页面如下

点击右上角的Admin Console

输入用户名和密码:分别是admin、springsource

进行管理页面

好啦,大功告成,我们的STS+Virgo初步的环境就搭建好了,下一节我们将介绍如何将Snaps集成到Virgo Server上,并演示几个官方的小demo。


kosuke 2016-08-22 17:51

不知道如何virgo是如何判断插件的启动顺序的,我的插件里明明有required-bundle,但它不按这个顺序启动,造成加载失败

顶(0) 踩(0) 回复

hasan 2016-04-28 10:27

自动升级安装virgo,要按照eclipse官网virgo的提示,http://download.eclipse.org/virgo/snapshot/tooling 才行

顶(0) 踩(0) 回复

曜月飞鹰 2015-12-21 14:16

回复空空大侠: 这个地址现在好像也不行了?

顶(0) 踩(0) 回复

空空大侠 2015-12-08 15:16

下载eclipse插件virgo tools,文中的地址不行,用这个可以:http://download.eclipse.org/virgo/snapshot/tooling (Needed for Eclipse Mars)

顶(0) 踩(0) 回复

yanguangpu 2015-09-30 12:35

virgo都有很多基础类了(MANIFEST.MF都引入了),为什么写自己的应用时还要maven导入jar

顶(0) 踩(0) 回复

arnold66 2015-07-23 16:27

回复jx_yangzhi: virgo 和felix 相比,哪个比较好?我看virgo更新的速度基本是半年才一次

顶(0) 踩(0) 回复

jx_yangzhi 2015-07-23 15:17

回复arnold66: 3.7 的STS http://download.eclipse.org/virgo/milestone/tooling这个路径下不支持,用最新的快照版本http://download.eclipse.org/virgo/snapshot/tooling (Needed for Eclipse Mars)

顶(0) 踩(0) 回复

zbeboy 2015-07-15 11:31

回复arnold66: STS后面的版本是不会安装virgo tools的,因为已经存在了,所以不会安装,也不会出现EclipseRT

顶(0) 踩(0) 回复

arnold66 2015-07-14 11:30

使用spring-tool-suite-3.7.0.RELEASE-e4.5-win32-x86_64.zip 开发包解压后安装virgo插件,安装成功后无EclipseRT选项怎么回事?

顶(0) 踩(0) 回复

洪庆斌 2015-05-16 17:08

回复shuangzhiling: D:\virgo\virgo-tomcat-server-3.6.3.RELEASE类似这样的安装路径,你不要包含空格或者中文

顶(0) 踩(0) 回复

shuangzhiling 2015-05-16 16:59

回复洪庆斌: 这个怎么解决的,错误: 找不到或无法加载主类 Files\virgo-tomcat-server-3.6.3.RELEASE.configuration.hostkey.ser<br>

顶(0) 踩(0) 回复

wmz 2015-04-29 14:05

找到一个OSGi的插件平台,详细参见:http://osgi.jxtech.net

顶(34) 踩(0) 回复

jlbone@sina.com 2015-01-19 10:55

回复enilu: 你就是新一代的雷锋

顶(1) 踩(0) 回复

洪庆斌 2015-01-17 22:15

回复洪庆斌: 原因以及找到,是因为virgo web server 配置的路径中包含了空格。大家注意点吧

顶(0) 踩(0) 回复

洪庆斌 2015-01-13 22:09

Eclipse3.8插件安装没有问题,但是执行测试环境的时候报:错误: 找不到或无法加载主类 Files。我使用的是jdk1.7,有遇到类似问题的朋友吗?交流一下。

顶(1) 踩(0) 回复

bill.li 2014-12-23 23:29

目前最新版本STS 3.6.3根本无法正常安装eclipse virgo tools,不知道是不是因为已经将spring dm给了eclipse,spring tool新版本对virgo的支持也变得这么不给力。实在没办法,只能下载eclipse indigo,安装sts for indigo,然后再安装eclipse virgo tools便成功了。

顶(0) 踩(0) 回复

enilu 2014-12-21 23:14

回复enilu: 后来重新安装一下,全程无报错,步骤如下:<br>1,安装eclipse:eclipse-jee-juno-SR2-win32-x86_64.zip,直接解压即可。<br>2,安装sts:下载离线版本sts:springsource-tool-suite-3.6.3.RELEASE-e4.2.2-updatesite.zip(要对应eclipse的版本eclipse-juno就是4.2的),解压后直接拷贝features和plugins目录到eclipse目录中,<br>3,安装virgo插件:在线安装virgo:http://download.eclipse.org/virgo/release/tooling<br>4,配置virgo-tomcat:irgo-tomcat:virgo-tomcat-server-3.6.3.RELEASE

顶(3) 踩(0) 回复

enilu 2014-12-18 11:31

第三步安装virgo tools插件的时候报错了<br>Cannot complete the install because one or more required items could not be found.<br> Software being installed: Eclipse Virgo Tools 1.0.0.201207122033-MILESTONE (org.eclipse.virgo.ide.feature.feature.group 1.0.0.201207122033-MILESTONE)<br> Missing requirement: Eclipse Virgo IDE (Bundlor Core) 1.0.0.201207122033-MILESTONE (org.eclipse.virgo.ide.bundlor.core 1.0.0.201207122033-MILESTONE) requires 'bundle org.objectweb.asm [3.1.0,4.0.0)' but it could not be found<br> Cannot satisfy dependency:<br> From: Eclipse Virgo Tools 1.0.0.201207122033-MILESTONE (org.eclipse.virgo.ide.feature.feature.group 1.0.0.201207122033-MILESTONE)<br> To: org.eclipse.virgo.ide.ui [1.0.0.201207122033-MILESTONE]<br> Cannot satisfy dependency:<br> From: Eclipse Virgo IDE (UI) 1.0.0.201207122033-MILESTONE (org.eclipse.virgo.ide.ui 1.0.0.201207122033-MILESTONE)<br> To: bundle org.eclipse.virgo.ide.bundlor.core 0.0.0<br>这些东西去哪里找呢,我使用的eclipse luna上安装sts后,安装virgo tools插件的

顶(0) 踩(0) 回复

enilu 2014-12-18 11:21

回复chris: 我也安装不上去

顶(0) 踩(0) 回复

saintpalading 2014-12-12 15:47

快折腾死了,高版本不行,下载3.7.2的eclipse,用更新包安装时,报错:<br>An error occurred while collecting items to be installed<br>session context was:(profile=epp.package.jee, phase=org.eclipse.equinox.internal.p2.engine.phases.Collect, operand=, action=).<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.bugzilla.core,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.bugzilla.ide,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.bugzilla.ui,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.commons.core,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.commons.identity,0.9.1.v20120412-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.commons.net,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.commons.repositories,0.9.1.v20120412-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.commons.screenshots,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.commons.team,0.9.1.v20120412-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.commons.ui,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.commons.xmlrpc,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.context.core,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.context.ui,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.discovery.core,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.discovery.ui,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.help.ui,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.ide.ant,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.ide.ui,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.java.tasks,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.java.ui,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.monitor.core,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.monitor.ui,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.resources.ui,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.tasks.bugs,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.tasks.core,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.tasks.search,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.tasks.ui,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.team.cvs,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.team.ui,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,com.google.protobuf,2.4.0.v201105131100<br>No repository found containing: osgi.bundle,com.ning.async-http-client,1.6.5.20130219-0923<br>No repository found containing: osgi.bundle,com.vmware.vfabric.ide.eclipse.tcserver.core,3.6.3.201411271101-RELEASE<br>No repository found containing: org.eclipse.update.feature,com.vmware.vfabric.ide.eclipse.tcserver,3.6.3.201411271101-RELEASE<br>No repository found containing: org.eclipse.update.feature,com.vmware.vfabric.ide.eclipse.tcserver.insight,3.6.3.201411271101-RELEASE<br>No repository found containing: osgi.bundle,com.vmware.vfabric.ide.eclipse.tcserver.insight.ui,3.6.3.201411271101-RELEASE<br>No repository found containing: osgi.bundle,com.vmware.vfabric.ide.eclipse.tcserver.livegraph,3.6.3.201411271101-RELEASE<br>No repository found containing: osgi.bundle,com.vmware.vfabric.ide.eclipse.tcserver.reloading,3.6.3.201411271101-RELEASE<br>No repository found containing: osgi.bundle,com.vmware.vfabric.ide.eclipse.tcserver.ui,3.6.3.201411271101-RELEASE<br>No repository found containing: osgi.bundle,javax.jms,1.1.0.v201205091237<br>No repository found containing: osgi.bundle,org.aspectj.ajde,1.7.0.20120703164200<br>No repository found containing: osgi.bundle,org.aspectj.runtime,1.7.0.20120703164200<br>No repository found containing: osgi.bundle,org.aspectj.runtime.source,1.7.0.20120703164200<br>No repository found containing: osgi.bundle,org.aspectj.weaver,1.7.0.20120703164200<br>No repository found containing: osgi.bundle,org.eclipse.ajdt.core,2.2.0.e37x-RELEASE-20120704-0900<br>No repository found containing: osgi.bundle,org.eclipse.ajdt.core.source,2.2.0.e37x-RELEASE-20120704-0900<br>No repository found containing: osgi.bundle,org.eclipse.ajdt.doc.user,2.2.0.e37x-RELEASE-20120704-0900<br>No repository found containing: osgi.bundle,org.eclipse.ajdt.examples,2.2.0.e37x-RELEASE-20120704-0900<br>No repository found containing: osgi.bundle,org.eclipse.ajdt.examples.source,2.2.0.e37x-RELEASE-20120704-0900<br>No repository found containing: org.eclipse.update.feature,org.eclipse.ajdt,2.2.0.e37x-RELEASE-20120704-0900<br>No repository found containing: osgi.bundle,org.eclipse.ajdt.mylyn.ui,2.2.0.e37x-RELEASE-20120704-0900<br>No repository found containing: osgi.bundle,org.eclipse.ajdt.mylyn.ui.source,2.2.0.e37x-RELEASE-20120704-0900<br>No repository found containing: org.eclipse.update.feature,org.eclipse.ajdt.source,2.2.0.e37x-RELEASE-20120704-0900<br>No repository found containing: osgi.bundle,org.eclipse.ajdt.ui,2.2.0.e37x-RELEASE-20120704-0900<br>No repository found containing: osgi.bundle,org.eclipse.ajdt.ui.source,2.2.0.e37x-RELEASE-20120704-0900<br>No repository found containing: osgi.bundle,org.eclipse.aspectj,2.2.0.e37x-RELEASE-20120704-0900<br>No repository found containing: osgi.bundle,org.eclipse.contribution.visualiser,2.2.0.e37x-RELEASE-20120704-0900<br>No repository found containing: osgi.bundle,org.eclipse.contribution.visualiser.source,2.2.0.e37x-RELEASE-20120704-0900<br>No repository found containing: org.eclipse.update.feature,org.eclipse.contribution.weaving,2.2.0.e37x-RELEASE-20120704-0900<br>No repository found containing: osgi.bundle,org.eclipse.contribution.weaving.jdt,2.2.0.e37x-RELEASE-20120704-0900<br>No repository found containing: osgi.bundle,org.eclipse.contribution.weaving.jdt.source,2.2.0.e37x-RELEASE-20120704-0900<br>No repository found containing: org.eclipse.update.feature,org.eclipse.contribution.weaving.source,2.2.0.e37x-RELEASE-20120704-0900<br>No repository found containing: osgi.bundle,org.eclipse.contribution.xref.core,2.2.0.e37x-RELEASE-20120704-0900<br>No repository found containing: osgi.bundle,org.eclipse.contribution.xref.core.source,2.2.0.e37x-RELEASE-20120704-0900<br>No repository found containing: org.eclipse.update.feature,org.eclipse.contribution.xref,2.2.0.e37x-RELEASE-20120704-0900<br>No repository found containing: org.eclipse.update.feature,org.eclipse.contribution.xref.source,2.2.0.e37x-RELEASE-20120704-0900<br>No repository found containing: osgi.bundle,org.eclipse.contribution.xref.ui,2.2.0.e37x-RELEASE-20120704-0900<br>No repository found containing: osgi.bundle,org.eclipse.contribution.xref.ui.source,2.2.0.e37x-RELEASE-20120704-0900<br>No repository found containing: osgi.bundle,org.eclipse.equinox.weaving.aspectj,1.0.100.I20120427-0800<br>No repository found containing: osgi.bundle,org.eclipse.equinox.weaving.aspectj.source,1.0.100.I20120427-0800<br>No repository found containing: osgi.bundle,org.eclipse.equinox.weaving.caching,1.0.100.I20120427-0800<br>No repository found containing: osgi.bundle,org.eclipse.equinox.weaving.caching.j9,1.0.100.I20120427-0800<br>No repository found containing: osgi.bundle,org.eclipse.equinox.weaving.caching.j9.source,1.0.100.I20120427-0800<br>No repository found containing: osgi.bundle,org.eclipse.equinox.weaving.caching.source,1.0.100.I20120427-0800<br>No repository found containing: osgi.bundle,org.eclipse.equinox.weaving.hook,1.0.200.I20120427-0800<br>No repository found containing: osgi.bundle,org.eclipse.equinox.weaving.hook.source,1.0.200.I20120427-0800<br>No repository found containing: org.eclipse.update.feature,org.eclipse.equinox.weaving.sdk,1.0.200.I20120427-0800<br>No repository found containing: osgi.bundle,org.eclipse.fx.core,0.9.0.201401250701<br>No repository found containing: osgi.bundle,org.eclipse.fx.javafx,2.2.0.201401250701<br>No repository found containing: osgi.bundle,org.eclipse.fx.osgi,0.9.0.201401250701<br>No repository found containing: osgi.bundle,org.eclipse.fx.osgi.util,0.9.0.201401250701<br>No repository found containing: osgi.bundle,org.eclipse.m2e.archetype.common,1.3.1.20130219-0923<br>No repository found containing: osgi.bundle,org.eclipse.m2e.core,1.3.1.20130219-1424<br>No repository found containing: osgi.bundle,org.eclipse.m2e.core.ui,1.3.1.20130219-1424<br>No repository found containing: osgi.bundle,org.eclipse.m2e.maven.indexer,1.3.1.20130219-0923<br>No repository found containing: osgi.bundle,org.eclipse.m2e.maven.runtime,1.3.1.20130219-0923<br>No repository found containing: osgi.bundle,org.eclipse.m2e.model.edit,1.3.1.20130219-1424<br>No repository found containing: org.eclipse.update.feature,org.eclipse.mylyn.bugzilla_feature,3.8.4.v20130429-0100<br>No repository found containing: org.eclipse.update.feature,org.eclipse.mylyn.commons,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.commons.identity.core,1.0.4.v20130429-0100<br>No repository found containing: org.eclipse.update.feature,org.eclipse.mylyn.commons.identity,1.0.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.commons.notifications,0.9.1.v20120412-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.commons.notifications.core,1.0.4.v20130429-0100<br>No repository found containing: org.eclipse.update.feature,org.eclipse.mylyn.commons.notifications,1.0.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.commons.notifications.feed,1.0.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.commons.notifications.ui,1.0.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.commons.repositories.core,1.0.4.v20130429-0100<br>No repository found containing: org.eclipse.update.feature,org.eclipse.mylyn.commons.repositories,1.0.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.commons.repositories.ui,1.0.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.commons.workbench,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.context.tasks.ui,3.8.4.v20130429-0100<br>No repository found containing: org.eclipse.update.feature,org.eclipse.mylyn.context_feature,3.8.4.v20130429-0100<br>No repository found containing: org.eclipse.update.feature,org.eclipse.mylyn.discovery,3.8.4.v20130429-0100<br>No repository found containing: org.eclipse.update.feature,org.eclipse.mylyn.ide_feature,3.8.4.v20130429-0100<br>No repository found containing: org.eclipse.update.feature,org.eclipse.mylyn.java_feature,3.8.4.v20130429-0100<br>No repository found containing: org.eclipse.update.feature,org.eclipse.mylyn.monitor,3.8.4.v20130429-0100<br>No repository found containing: org.eclipse.update.feature,org.eclipse.mylyn.tasks.ide,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.tasks.index.core,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.eclipse.mylyn.tasks.index.ui,3.8.4.v20130429-0100<br>No repository found containing: org.eclipse.update.feature,org.eclipse.mylyn.team_feature,3.8.4.v20130429-0100<br>No repository found containing: org.eclipse.update.feature,org.eclipse.mylyn_feature,3.8.4.v20130429-0100<br>No repository found containing: osgi.bundle,org.jboss.netty,3.2.5.Final-20130219-0923<br>No repository found containing: osgi.bundle,org.slf4j.api,1.6.4.v20120130-2120<br>No repository found containing: osgi.bundle,org.springframework.aop,4.0.2.20140223-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.aop.source,4.0.2.20140223-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.beans,4.0.2.20140223-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.beans.source,4.0.2.20140223-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.context,4.0.2.20140223-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.context.source,4.0.2.20140223-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.context.support,4.0.2.20140223-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.context.support.source,4.0.2.20140223-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.core,4.0.2.20140223-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.core.source,4.0.2.20140223-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.data.core,1.7.0.20140120-CI<br>No repository found containing: osgi.bundle,org.springframework.data.core.source,1.7.0.20140120-CI<br>No repository found containing: osgi.bundle,org.springframework.expression,4.0.2.20140223-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.expression.source,4.0.2.20140223-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse,3.6.3.201411271034-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.ajdt.feature,3.6.3.201411271034-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.ajdt.feature.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.ajdt.ui.visualiser,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.ajdt.ui.visualiser.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.ajdt.ui.xref,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.ajdt.ui.xref.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.aop.core,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.aop.core.source,3.6.3.201411271034-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.aop.feature,3.6.3.201411271034-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.aop.feature.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.aop.mylyn,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.aop.mylyn.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.aop.ui,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.aop.ui.matcher,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.aop.ui.matcher.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.aop.ui.source,3.6.3.201411271034-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.autowire.feature,3.6.3.201411271034-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.autowire.feature.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.batch,3.6.3.201411271034-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.batch.feature,3.6.3.201411271034-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.batch.feature.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.batch.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.beans.core,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.beans.core.autowire,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.beans.core.autowire.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.beans.core.metadata,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.beans.core.metadata.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.beans.core.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.beans.mylyn,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.beans.mylyn.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.beans.ui,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.beans.ui.autowire,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.beans.ui.autowire.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.beans.ui.editor,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.beans.ui.editor.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.beans.ui.graph,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.beans.ui.graph.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.beans.ui.livegraph,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.beans.ui.livegraph.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.beans.ui.refactoring,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.beans.ui.refactoring.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.beans.ui.search,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.beans.ui.search.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.beans.ui.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.bestpractices,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.bestpractices.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.boot,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.boot.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.config.core,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.config.core.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.config.graph,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.config.graph.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.config.ui,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.config.ui.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.core,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.core.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.data.core,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.data.core.source,3.6.3.201411271034-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.data.feature,3.6.3.201411271034-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.data.feature.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.doc,3.6.3.201411271034-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.feature,3.6.3.201411271034-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.feature.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.integration,3.6.3.201411271034-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.integration.feature,3.6.3.201411271034-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.integration.feature.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.integration.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.maven,3.6.3.201411271034-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.maven.feature,3.6.3.201411271034-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.maven.feature.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.maven.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.metadata,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.metadata.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.mylyn,3.6.3.201411271034-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.mylyn.feature,3.6.3.201411271034-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.mylyn.feature.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.mylyn.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.osgi,3.6.3.201411271034-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.osgi.feature,3.6.3.201411271034-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.osgi.feature.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.osgi.runtime,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.osgi.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.osgi.targetdefinition,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.quickfix,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.quickfix.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.roo.core,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.roo.core.source,3.6.3.201411271034-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.roo.feature,3.6.3.201411271034-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.roo.feature.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.roo.ui,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.roo.ui.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.security,3.6.3.201411271034-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.security.feature,3.6.3.201411271034-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.security.feature.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.security.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.uaa,3.6.3.201411271002-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.uaa.feature,3.6.3.201411271002-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.uaa.feature.source,3.6.3.201411271002-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.uaa.source,3.6.3.201411271002-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.ui,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.ui.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.webflow.core,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.webflow.core.source,3.6.3.201411271034-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.webflow.feature,3.6.3.201411271034-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springframework.ide.eclipse.webflow.feature.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.webflow.mylyn,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.webflow.mylyn.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.webflow.ui,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.webflow.ui.editor,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.webflow.ui.editor.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.webflow.ui.graph,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.webflow.ui.graph.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.webflow.ui.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.wizard,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.ide.eclipse.wizard.source,3.6.3.201411271034-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.jdbc,4.0.2.20140223-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.jdbc.source,4.0.2.20140223-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.jms,4.0.2.20140223-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.jms.source,4.0.2.20140223-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.orm,4.0.2.20140223-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.orm.source,4.0.2.20140223-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.oxm,4.0.2.20140223-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.oxm.source,4.0.2.20140223-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.roo.wrapping.bcpg-jdk15,1.45.0.0001<br>No repository found containing: osgi.bundle,org.springframework.roo.wrapping.bcprov-jdk15,1.45.0.0001<br>No repository found containing: osgi.bundle,org.springframework.roo.wrapping.json-simple,1.1.0.0010<br>No repository found containing: osgi.bundle,org.springframework.transaction,4.0.2.20140223-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.transaction.source,4.0.2.20140223-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.uaa.client,1.0.3.RELEASE<br>No repository found containing: osgi.bundle,org.springframework.web,4.0.2.20140223-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.web.servlet,4.0.2.20140223-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.web.servlet.source,4.0.2.20140223-RELEASE<br>No repository found containing: osgi.bundle,org.springframework.web.source,4.0.2.20140223-RELEASE<br>No repository found containing: osgi.bundle,org.springsource.ide.eclipse.commons.browser,3.6.3.201411271002-RELEASE<br>No repository found containing: osgi.bundle,org.springsource.ide.eclipse.commons.completions,3.6.3.201411271002-RELEASE<br>No repository found containing: osgi.bundle,org.springsource.ide.eclipse.commons.configurator,3.6.3.201411271002-RELEASE<br>No repository found containing: osgi.bundle,org.springsource.ide.eclipse.commons.content.core,3.6.3.201411271002-RELEASE<br>No repository found containing: osgi.bundle,org.springsource.ide.eclipse.commons.core,3.6.3.201411271002-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springsource.ide.eclipse.commons,3.6.3.201411271002-RELEASE<br>No repository found containing: osgi.bundle,org.springsource.ide.eclipse.commons.frameworks.core,3.6.3.201411271002-RELEASE<br>No repository found containing: osgi.bundle,org.springsource.ide.eclipse.commons.frameworks.ui,3.6.3.201411271002-RELEASE<br>No repository found containing: osgi.bundle,org.springsource.ide.eclipse.commons.gettingstarted,3.6.3.201411271002-RELEASE<br>No repository found containing: osgi.bundle,org.springsource.ide.eclipse.commons.livexp,3.6.3.201411271002-RELEASE<br>No repository found containing: osgi.bundle,org.springsource.ide.eclipse.commons.quicksearch,3.6.3.201411271002-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springsource.ide.eclipse.commons.quicksearch.feature,3.6.3.201411271002-RELEASE<br>No repository found containing: osgi.bundle,org.springsource.ide.eclipse.commons.ui,3.6.3.201411271002-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springsource.ide.eclipse.dashboard,3.6.3.201411271002-RELEASE<br>No repository found containing: osgi.bundle,org.springsource.ide.eclipse.dashboard.ui,3.6.3.201411271002-RELEASE<br>No repository found containing: osgi.bundle,org.springsource.ide.eclipse.gradle.core,3.6.3.201411271013-RELEASE<br>No repository found containing: org.eclipse.update.feature,org.springsource.ide.eclipse.gradle.feature,3.6.3.201411271013-RELEASE<br>No repository found containing: osgi.bundle,org.springsource.ide.eclipse.gradle.toolingapi,3.6.3.201411271013-RELEASE<br>No repository found containing: osgi.bundle,org.springsource.ide.eclipse.gradle.ui,3.6.3.201411271013-RELEASE<br>No repository found containing: osgi.bundle,org.springsource.ide.eclipse.gradle.ui.taskview,3.6.3.201411271013-RELEASE

顶(0) 踩(3) 回复

youleyang 2014-11-19 10:40

我在我的Eclipse上安装成功了(Eclipse Java EE IDE for Web Developers.Version: Indigo)。虽然不是100%按照上面操作的,(按照上面的操作会有些问题)但是最后还是成功了~~

顶(0) 踩(0) 回复

冯云刚 2014-11-11 14:21

回复chris: springsource-tool-suite-2.9.2.RELEASE-e3.7.2-win32-x86_64 你们用这个版本的去安装第三部的东西是可以的

顶(0) 踩(0) 回复

冯云刚 2014-11-11 14:10

回复CoderKe: springsource-tool-suite-2.9.2.RELEASE-e3.7.2-win32-x86_64 你们用这个版本的去安装第三部的东西是可以的

顶(0) 踩(0) 回复

冯云刚 2014-11-11 14:10

回复冷冰冰: springsource-tool-suite-2.9.2.RELEASE-e3.7.2-win32-x86_64 你们用这个版本的去安装第三部的东西是可以的

顶(0) 踩(0) 回复

冯云刚 2014-11-11 14:09

springsource-tool-suite-2.9.2.RELEASE-e3.7.2-win32-x86_64 你们用这个版本的去安装第三部的东西是可以的

顶(0) 踩(0) 回复

CoderKe 2014-10-09 09:48

回复孤单骑行客: 我也安装插件失败。不知道什么原因

顶(1) 踩(8) 回复

冷冰冰 2014-09-29 17:21

STS 3.6.1无法正常安装virgo tools <br>No repository found containing: osgi.bundle,com.vmware.vfabric.ide.eclipse.tcserver.insight.ui,3.6.1.201408250746-RELEASE

顶(1) 踩(0) 回复

zhang90030 2014-09-14 18:28

之前用的MyEclipse2014,安装virgo时,说conflicting dependency,应该是因为版本不兼容。<br>最后用的J2EE4.3.2(Keperl),把STS插件安上,再安装virgo中提示一个错误,忽略之后,成功安装了,启动的时候,又出现Failed to start Tomcat. Port 8443 is in use. <br>把tomcat-server.xml文件中的8843替换成其它端口,发现可以运行了。<br>不知道virgo那个错误会不会影响后面的工作??

顶(0) 踩(0) 回复

wangcansun 2014-09-13 20:30

回复eastcowry: 因为osgi的jar包更新了,而virgo tools里面还是旧的,导致了安装不了

顶(0) 踩(0) 回复

eastcowry 2014-08-21 11:41

我也在安装插件那失败,能指教一下么

顶(1) 踩(0) 回复

孤单骑行客 2014-08-06 19:40

步骤三,安装插件失败…求大神回复

顶(6) 踩(0) 回复

菜鸟程序员 2014-07-28 16:23

spring-tool-suite-3.6.0.RELEASE-e4.4-win32-x86_64<br>无法正常安装clipse Virgo Tools插件

顶(5) 踩(0) 回复

ttjegd 2014-07-15 16:03

很好,说得很清楚。

顶(0) 踩(40) 回复

chris 2014-06-08 02:52

spring-tool-suite-3.5.1.RELEASE-e3.8.2-win32-x86_64<br>无法正常安装clipse Virgo Tools插件

顶(416) 踩(0) 回复

李俊辉 2014-06-06 11:12

animal jar部署不上去哦,不知道是什么原因。显示错误:Nothing deployed!

顶(0) 踩(0) 回复

李俊辉 2014-06-06 09:00

为什么没有下载Based on Eclipse4.3.2 呢?而要下载Based on Eclipse 3.8.2?这两个版本有什么区别吗?

顶(0) 踩(0) 回复

王传银 2014-05-29 13:17

非常感谢,分享。

顶(0) 踩(0) 回复
查看评论